using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Vodopad
{
    class Program
    {
        static void Main(string[] args)
        {
            string[] ulaz = Console.ReadLine().Split();
            long h = Convert.ToInt64(ulaz[0]);
            long n = Convert.ToInt64(ulaz[1]);

            bool[,] kamenje = new bool[h + 1, n];
            long[,] voda = new long[h + 1, n];

            for (int i = 1; i < h + 1; i++)
            {
                ulaz = Console.ReadLine().Split();
                for (int j = 0; j < n; j++)
                {
                    kamenje[i, j] = Convert.ToBoolean(Convert.ToInt32(ulaz[j]));
                }
            }
            for (int i = 0; i < n; i++) kamenje[0, i] = true;


            for (int i = 0; i < h + 1; i++)
            {
                for (int j = 0; j < n; j++)
                {
                    if (i == 0) voda[i, j] = 1;
                    else voda[i, j] = 0;
                }
            }


            for (int i = 0; i < h; i++)
            {
                for (int j = 0; j < n; j++)
                {
                    if (kamenje[i, j] = !false)
                    {
                        if (kamenje[i + 1, j] != true)
                        {
                            bool levo = false;
                            bool desno = false;

                            int loclevo = 0;
                            int locdesno = 0;

                            for (int k = 1; k < n - 1; k++)
                            {
                                //idemo na levo
                                if (j - k >= 0 && levo == false)
                                {
                                    if (kamenje[i + 1, j - k] != false)
                                    {
                                        levo = true;
                                        loclevo = j - k;
                                    }
                                }

                                //idemo desno
                                if (j + k < n && desno == false)
                                {
                                    if (kamenje[i + 1, j + k] != false)
                                    {
                                        desno = true;
                                        locdesno = j + k;
                                    }
                                }

                                if (levo == true && desno == true) break;
                            }

                            //dodajemo levo
                            if (levo == true && desno == false)
                            {
                                voda[i + 1, loclevo] += voda[i, j];
                            }

                            //dodajemo desno
                            else if (desno == true && levo == false)
                            {
                                voda[i + 1, locdesno] += voda[i, j];
                            }

                            //dodajemo oba
                            else if (levo == true && desno == true)
                            {
                                voda[i + 1, loclevo] += voda[i, j] / 2;
                                voda[i + 1, locdesno] += voda[i, j] / 2;

                                if (voda[i, j] % 2 == 1)
                                {
                                    if ((i + 1) % 2 == 0)
                                    {
                                        voda[i + 1, locdesno]++;
                                    }
                                    else
                                    {
                                        voda[i + 1, loclevo]++;
                                    }
                                }


                            }
                        }
                        else
                        {
                            voda[i + 1, j] += voda[i, j];
                        }
                    }
                }
            }

            for (int j = 0; j < n; j++)
            {
                Console.Write(voda[h, j] + " ");
            }
            Console.WriteLine();
        }
    }
}